import type { AccessKeyPropType, AlternativeButtonLinkRolePropType, AriaDescriptionPropType, ButtonAPI, ButtonCallbacksPropType, ButtonStates, ButtonTypePropType, ButtonVariantPropType, CustomClassPropType, DisabledPropType, FocusableElement, IconsPropType, LabelWithExpertSlotPropType, ShortKeyPropType, StencilUnknown, Stringified, SyncValueBySelectorPropType, TooltipAlignPropType } from '../../schema';
import type { JSX } from '../../stencil-public-runtime';
export declare class KolButtonWc implements ButtonAPI, FocusableElement {
    private readonly host?;
    private buttonRef?;
    private readonly internalDescriptionById;
    private readonly catchRef;
    kolFocus(): Promise<void>;
    private readonly onClick;
    render(): JSX.Element;
    private readonly controller;
    _accessKey?: AccessKeyPropType;
    _ariaControls?: string;
    _ariaDescription?: AriaDescriptionPropType;
    _ariaExpanded?: boolean;
    _ariaSelected?: boolean;
    _customClass?: CustomClassPropType;
    _disabled?: boolean;
    _hideLabel?: boolean;
    _icons?: IconsPropType;
    _id?: string;
    _label: LabelWithExpertSlotPropType;
    _name?: string;
    _on?: ButtonCallbacksPropType<StencilUnknown>;
    _role?: AlternativeButtonLinkRolePropType;
    _shortKey?: ShortKeyPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tabIndex?: number;
    _tooltipAlign?: TooltipAlignPropType;
    _type?: ButtonTypePropType;
    _value?: Stringified<StencilUnknown>;
    _variant?: ButtonVariantPropType;
    state: ButtonStates;
    constructor();
    validateAccessKey(value?: AccessKeyPropType): void;
    validateAriaControls(value?: string): void;
    validateAriaDescription(value?: AriaDescriptionPropType): void;
    validateAriaExpanded(value?: boolean): void;
    validateAriaSelected(value?: boolean): void;
    validateCustomClass(value?: CustomClassPropType): void;
    validateDisabled(value?: DisabledPropType): void;
    validateHideLabel(value?: boolean): void;
    validateIcons(value?: IconsPropType): void;
    validateId(value?: string): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateName(value?: string): void;
    validateOn(value?: ButtonCallbacksPropType<StencilUnknown>): void;
    validateRole(value?: AlternativeButtonLinkRolePropType): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTabIndex(value?: number): void;
    validateTooltipAlign(value?: TooltipAlignPropType): void;
    validateType(value?: ButtonTypePropType): void;
    validateValue(value?: Stringified<StencilUnknown>): void;
    validateVariant(value?: ButtonVariantPropType): void;
    componentWillLoad(): void;
}
